CREATE TABLE IF NOT EXISTS `prefix_config` (
  `config_name` char(20) NOT NULL,
  `config_value` text NOT NULL,
  UNIQUE KEY `config_name` (`config_name`)
) ENGINE=MyISAM ;

CREATE TABLE IF NOT EXISTS `prefix_session` (
  `uname` char(25) NOT NULL default '',
  `time` char(14) NOT NULL default '',
  `host_addr` char(48) NOT NULL default '',
  `guest` int(1) NOT NULL default '0',
  `Wurl` char(255) NOT NULL default '',
  `Wname` char(255) NOT NULL default '',
  KEY `time` (`time`),
  KEY `guest` (`guest`)
) ENGINE=MyISAM ;

CREATE TABLE IF NOT EXISTS `prefix_twitter` (
  `id` int(11) NOT NULL auto_increment,
  `tweet` varchar(250) NOT NULL,
  `who` varchar(35) NOT NULL,
  `avatar` varchar(100) NOT NULL,
  `reponse` varchar(35) NOT NULL,
  `via` varchar(20) NOT NULL,
  `xtime` varchar(14) NOT NULL,
  `datetime` datetime NOT NULL default '0000-00-00 00:00:00',
  `ip` varchar(15) NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `who` (`who`),
  KEY `xtime` (`xtime`),
  KEY `active` (`active`),
  KEY `reponse` (`reponse`)
) ENGINE=MyISAM ;

CREATE TABLE IF NOT EXISTS `prefix_twitter_account` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `who` char(35) NOT NULL,
  `nom` varchar(100) NOT NULL,
  `photo` varchar(100) NOT NULL,
  `local` varchar(100) NOT NULL,
  `web` varchar(100) NOT NULL,
  `bio` varchar(150) NOT NULL,
  `xtime` char(14) NOT NULL,
  `datetime` datetime NOT NULL default '0000-00-00 00:00:00',
  `active` tinyint(1) NOT NULL default '1',
  `total` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `uid` (`uid`),
  KEY `who` (`who`),
  KEY `active` (`active`),
  KEY `total` (`total`)
) ENGINE=MyISAM ;

CREATE TABLE IF NOT EXISTS `prefix_users` (
  `user_id` int(10) NOT NULL auto_increment,
  `username` char(50) NOT NULL,
  `user_email` char(60) NOT NULL,
  `user_password` char(40) NOT NULL,
  `user_website` char(50) NOT NULL,
  `user_active` tinyint(1) NOT NULL default '0',
  `adjoint` tinyint(1) NOT NULL default '0',
  `language` char(15) NOT NULL default 'french',
  `date_reg` datetime NOT NULL,
  `last_visit` datetime NOT NULL,
  PRIMARY KEY  (`user_id`),
  KEY `username` (`username`),
  KEY `user_email` (`user_email`),
  KEY `user_password` (`user_password`),
  KEY `user_active` (`user_active`)
) ENGINE=MyISAM ;
