<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009                                                   */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied firewall MINIMUS directly...');

define('GET_QUERY_STRING', strtolower( get_query_string() ) );
define('USER_AGENT', get_user_agent() );
define('GET_IP', get_ip() );
define('GET_REFERER', get_referer() );
define('REQUEST_URI', URLE);
define('GET_REQUEST_METHOD', get_request_method() );
//SEE TECHNOCRAT below
define('REGEX_UNION','#\w?\s?union\s\w*?\s?(select|all|distinct|insert|update|drop|delete)#is');


if(is_array($user)) {
	$user = implode(':', $user);
	$user = base64_encode($user);
}
$userinfo = GetUsrinfo($user);

if ( ACTIVATION_FIREWALL === true ) {
	/** protection de l'url */
	if ( PROTECTION_URL === true ) {
		$ct_rules = array( ' and ', ' xor ', '%20and%20', '%20xorg%20', 'http:' );
		$check    = str_replace($ct_rules, '*', GET_QUERY_STRING );
		if( GET_QUERY_STRING != $check ) {
			header("location: index.php");die();
		}
	}

	/** protection contre le flood */
	if ( PROTECTION_FLOOD === true ) {
		if (is_file(INCLUDE_PATH.'kernel/class/class.floodblocker.php'))
			include_once ( INCLUDE_PATH.'kernel/class/class.floodblocker.php' );
		$flb = new FloodBlocker ( INCLUDE_PATH.''.CACHE.'/flood/' );
		$flb->rules = array (
			10=>30,    // rule 1 - maximum 30 requests in 10 secs
			60=>300,    // rule 2 - maximum 300 requests in 60 secs
			300=>500,   // rule 3 - maximum 500 requests in 300 secs
			3600=>7200  // rule 4 - maximum 7200 requests in 3600 secs
		);
		if ( ! $flb->CheckFlood() ) {
			die('flood detection ! stop it ...');
		}
	}

	/** Posting from other servers in not allowed */
	if ( PROTECTION_REQUEST_SERVER === true ) {
		if ( GET_REQUEST_METHOD == 'POST' ) {
			if (isset($_SERVER['HTTP_REFERER'])) {
				if (!stripos_clone($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST'])) {
					die('Posting from another server not allowed!');
				}
			}
		}
	}

	/** protection contre le vers santy */
	if ( PROTECTION_SANTY === true ) {
		$bad_uri_content=array('rush','highlight=%','perl','chr(','pillar','visualcoder','sess_');
			while(list($stid,$uri_content)=each($bad_uri_content)) {
			if(stristr( REQUEST_URI , $uri_content)) {
				die('Attaque Santy detected ! Stop it ...');
			}
		}
	}

	/** Invalid request method check */
	if ( PROTECTION_REQUEST_METHOD === true ) {
		if(strtolower(GET_REQUEST_METHOD)!='get' AND strtolower(GET_REQUEST_METHOD)!='head' AND strtolower(GET_REQUEST_METHOD)!='post' AND strtolower(GET_REQUEST_METHOD)!='put') {
			die('Invalid request method check ! Stop it ...');
		}
	}

	/** protection dos attaque */
	if ( PROTECTION_DOS === true ) {
		if ( !defined('USER_AGENT')  || USER_AGENT == '-' )
			die('Invalid user agent ! Stop it ...');
	}

	/** protection union sql attaque */
	if ( PROTECTION_UNION_SQL === true ) {
		$ct_rules = array( '*/from/*', '*/insert/*', '+into+', '%20into%20', '*/into/*', ' into ', 'into', '*/limit/*', 'not123exists*', '*/radminsuper/*', '*/select/*', '+select+', '%20select%20', ' select ',  '+union+', '%20union%20', '*/union/*', ' union ', '*/update/*', '*/where/*' );
		$check    = str_replace($ct_rules, '*', GET_QUERY_STRING );
		if( GET_QUERY_STRING != $check ) die('UNion attack detected ! stop it ...');
		if (preg_match(REGEX_UNION, GET_QUERY_STRING)) die('Union attack detected ! stop it ....');
		if (preg_match('/([OdWo5NIbpuU4V2iJT0n]{5}) /', rawurldecode( GET_QUERY_STRING ))) die('Union attack detected ! stop it .....');
		if (strstr(rawurldecode( GET_QUERY_STRING ) ,'*')) die('Union attack detected ! stop it ......');
	}

	/** protection click attack */
	if ( PROTECTION_CLICK_ATTACK === true ) {
		$ct_rules = array( '/*', 'c2nyaxb0', 'http://', '/*' );
		if( GET_QUERY_STRING != str_replace($ct_rules, '*', GET_QUERY_STRING ) ) die('Click attack detected ! stop it .....');
	}

	/** protection XSS attack */
	if ( PROTECTION_XSS_ATTACK === true ) {
		$ct_rules = array( 'http\:\/\/', 'https\:\/\/', 'cmd=', '&cmd', 'exec', 'execu', 'concat', '../', 'http://', 'https://', 'ftp://', 'ftps://', 'index.php?url=' );
		$check    = str_replace($ct_rules, '*', GET_QUERY_STRING );
		if( GET_QUERY_STRING != $check ) die('XSS attack detected ! stop it ...');
	}
}

/** fonctions de base */
FUNCTION get_env($st_var) {
	global $HTTP_SERVER_VARS;
	if(isset($_SERVER[$st_var])) {
		return strip_tags( $_SERVER[$st_var] );
	} elseif(isset($_ENV[$st_var])) {
		return strip_tags( $_ENV[$st_var] );
	} elseif(isset($HTTP_SERVER_VARS[$st_var])) {
		return strip_tags( $HTTP_SERVER_VARS[$st_var] );
	} elseif(getenv($st_var)) {
		return strip_tags( getenv($st_var) );
	} elseif(function_exists('apache_getenv') && apache_getenv($st_var, true)) {
		return strip_tags( apache_getenv($st_var, true) );
	}
	return '';
}

FUNCTION get_referer() {
  	if( get_env('HTTP_REFERER') ) {
    		return get_env('HTTP_REFERER');
	}
	return 'no referer';
}

FUNCTION get_ip() {
	if ( get_env('HTTP_X_FORWARDED_FOR') ) {
		return get_env('HTTP_X_FORWARDED_FOR');
	} elseif ( get_env('HTTP_CLIENT_IP') ) {
		return get_env('HTTP_CLIENT_IP');
	} else {
		return get_env('REMOTE_ADDR');
	}
}
FUNCTION get_user_agent() {
  	if(get_env('HTTP_USER_AGENT')) {
    		return get_env('HTTP_USER_AGENT');
  	}
  	return 'none';
}

FUNCTION get_query_string() {
  	if( get_env('QUERY_STRING') ) {
    		return str_replace("%09", "%20", get_env('QUERY_STRING'));
  	}
  	return '';
}
FUNCTION get_request_method() {
  	if(get_env('REQUEST_METHOD')) {
    		return get_env('REQUEST_METHOD');
  	}
  	return 'none';
}
FUNCTION get_remote_addr () {
  	if(get_env('REMOTE_ADDR')) {
		return get_env('REMOTE_ADDR');
	}
  	return 'none';
}