<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') OR die ('Access denied header.php MINIMUS directly...');

/** GoogleTap SG */
if ( URL_FRIENDLY === true ) GoogleTap_SG::GTv2_header();

/** Haut de site */
Function Head() {
	global $sitename, $cookie, $pagetitle, $db, $ThemeSel, $currentlang, $rewrite;

	$tmp = INCLUDE_PATH.'kernel/themes.php';
	if (is_file( $tmp )) include_once( $tmp );

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML '._DOCTYPE.'//EN"'."\n"
	    .'"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n"
	    .'<html xmlns="http://www.w3.org/1999/xhtml" '._DOCTYPE_LANG.'>'."\n"
	    .'<head>'."\n\n"
	    .'<!-- PHP Kweeker / Minimus Blog and CMS 2010 XHTML 1.0 Strict valide -->'."\n\n";

	/** Load titre dynamique hors forums */
	isset( $sitename ) ? $sitename = secure( $sitename, '', 'clean') : $sitename = '';
	isset( $pagetitle ) ? $pagetitle = secure( $pagetitle, '', 'clean', '') : $pagetitle = '';
	$pagetitle = str_replace('-', '', $pagetitle);
	echo '<title>'.$pagetitle.' '.$sitename.'</title>'."\n";

	/** Anti Duplicate Content */
	if ( defined('URL_CANONICAL') )
		echo '<link rel="canonical" href="http://'.URL_SITE.''.URL_CANONICAL.'" />'."\n";

	/** load dynamic meta */
	$tmp = INCLUDE_PATH.'kernel/meta.php';
	if (is_file( $tmp )) include_once( $tmp );

	/** load all javascript */
	$tmp = INCLUDE_PATH.'kernel/javascript.php';
	if (is_file( $tmp )) include_once( $tmp );

	/** load popup manager */
	if ( defined('JAVASCRIPT_POPUP') )
		include_once (INCLUDE_PATH.'kernel/popup.php');

	/** load favicon */
	if ( is_file( INCLUDE_PATH.'favicon.ico' ) )
		echo '<link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />'."\n";

	/** load style forum fluxbb */
	if( defined('PUN_USER_STYLE') ) {
		echo '<style type="text/css"> @import url(modules/Fluxbb/style/'.PUN_USER_STYLE.'.css); </style>'."\n";
		if( defined('PUN_ADMIN_CONSOLE') ) {
			echo '<style type="text/css"> @import url(modules/Fluxbb/style/imports/base_admin.css); </style>'."\n";
		}
	}
	if ( is_module('Blogs') ) {
		( $rewrite == 1 ) ? $url = 'blog_rss.html' : $url = 'index.php?name=Blogs&amp;op=rss';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?RSS" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
		( $rewrite == 1 ) ? $url = 'blog_rssC.html' : $url = 'index.php?name=Blogs&amp;op=rssC';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?RSS" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
		( $rewrite == 1 ) ? $url = 'blog_atom.html' : $url = 'index.php?name=Blogs&amp;op=atom';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?ATOM" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
		( $rewrite == 1 ) ? $url = 'blog_atomC.html' : $url = 'index.php?name=Blogs&amp;op=atomC';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?ATOM" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
	}

	if ( is_module('Twitter') ) {
		( $rewrite == 1 ) ? $url = 'twitter_rss.html' : $url = 'index.php?name=Twitter&amp;op=rss';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?RSS" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
	}

	if ( is_module('Fluxbb') ) {
		( $rewrite == 1 ) ? $url = 'fluxbb_rss.html' : $url = 'index.php?name=Fluxbb&amp;op=rss';
		echo '<link rel="alternate" type="application/rss+xml" title="'.$sitename.' ?RSS" href="http://'.URL_SITE.'/'.$url.'" />'."\n";
	}

	/** load css */
	if ( defined('INCLUDE_RSS') ) echo INCLUDE_RSS;

	/** load css */
	if ( defined('INCLUDE_CSS') ) echo INCLUDE_CSS;

	/** load javascript */
	if ( defined('INCLUDE_JS') ) echo INCLUDE_JS;

	/** load meta link */
	if ( defined('META_LINK') ) echo META_LINK;

	/** load base css */
	if (is_file(INCLUDE_PATH.'kernel/style.css'))
		echo '<link rel="stylesheet" href="kernel/style.css" type="text/css" />'."\n";

	/** load dynamic css */
	if ( is_file( 'themes/'.$ThemeSel.'/style.css' ) ) {
		$style_minimus = 'themes/'.$ThemeSel.'/style.css';
	} else {
		$style_minimus = 'kernel/template/style.css';
	}
	echo '<link rel="stylesheet" href="'.$style_minimus.'" type="text/css" />'."\n";

	if (is_file(INCLUDE_PATH.'modules/'.MODULE_NAME.'/css/style.css'))
		echo '<link rel="stylesheet" href="modules/'.MODULE_NAME.'/css/style.css" type="text/css" />'."\n";

	/** load tabs */
	if (defined('CREATE_TABS')) {
		$tmp = INCLUDE_PATH.'kernel/tabs/tabdefault.php';
		if (is_file( $tmp )) include_once( $tmp );
		$tmp = INCLUDE_PATH.'kernel/addons/create_header.php';
		if (is_file( $tmp )) include_once( $tmp );
		CreateTabs( CREATE_TABS );
	}

	echo "\n".'</head>'."\n";

	/** load body */
	( defined('BODY') ) ? $body_minimus = '<body '.BODY.'>' : $body_minimus = '<body>';
 	echo $body_minimus."\n";

	$tmp = ROOT_PATH.'/'.CACHE.'/Configuration/'.PREFIX_CACHE.'_cache_minimus_menu.php';
	if ( is_file( $tmp ) ) {
		$menu =	file_get_contents( $tmp );
	} else {
		$menu = '';
		$menu .= "<ul><li><a href='./'>"._HOME."</a></li>";
		//$menu .= "<li><a href='index.php?name=Blogs'>"._MY_BLOG."</a></li>";
		$menu .= "<li><a href='index.php?name=MyAccount'>"._ACCOUNT."</a></li></ul>";
	}

	$tmp = INCLUDE_PATH.'themes/'.$ThemeSel.'/header.html';
	if ( is_file( $tmp ) ) {
		$tmpl_file2 = $tmp;
	} else {
		$tmpl_file2 = INCLUDE_PATH.'kernel/template/header.html';
	}

	$tmp = INCLUDE_PATH.'kernel/perso/custom_header.php';
	if (is_file( $tmp )) include_once( $tmp );

	$search = "<form action='index.php?name=Blogs' method='post'>
		<input type='text' name='query' value='' />
		<input type='hidden' name='op' value='search' />
		<input type='submit' name='submit' value='ok' />
		</form>";

    	$thefile2 = implode('', file($tmpl_file2));
    	$thefile2 = addslashes($thefile2);
    	$thefile2 = "\$r_file2=\"".$thefile2."\";";
   	eval( $thefile2 );
    	echo $r_file2;

	/** htaccess control security */
	if ( defined('ADMIN_ALLOW') AND ( ! is_file( '.htaccess') && is_file( 'sample.htaccess') ) )
		Div_Alert( '.HTACCESS ERROR !! '._HTACCESS_ERROR );

	/** mod debug  */
	if( ( MAXIMUS_DISPLAY_ERROR === true && ADMIN_ALLOW === true ) OR ( FORCE_DISPLAY_ERRORS === TRUE ) )
		Div_Alert( _ALERT_MOD_DEBUG_ERRORS_ACTIVE );

	/** mod debug errors */
	if ( @ ! empty(  $_COOKIE['mod_debug'] ) && defined('ADMIN_ALLOW') )
		Div_Alert( _ALERT_MOD_DEBUG_ACTIVE );
}

/** sessions maximus */
online();

/** load header complet */
head();