<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009                                                   */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied mysqli MINIMUS directly...');
if(!defined('SQL_LAYER')){

	define('SQL_LAYER','MySQLi');
	define('XMFbin_ERROR', 'Binaire error');
	define('XMFnum_ERROR', 'Numeraire error');
	define('XMFlang_ERROR', 'Language error');


	class sql_db{
		var $db_connect_id;
		var $query_result;
		var $row = array();
		var $num_queries = 0;
		var $sql_time = 0; // SQL excution time - added by Smartor

		public function timing(){
			list($usec, $sec) = explode(' ',microtime());
			return ((float)$usec + (float)$sec);
		}

		public function sql_db($sqlserver, $sqluser, $sqlpassword, $database, $persistency = false) {
			$start_time = $this->timing();
			$this->persistency = $persistency;
			$this->user = $sqluser;
			$this->password = $sqlpassword;
			$this->server = $sqlserver;
			$this->dbname = $database;
			$this->db_connect_id = @mysqli_connect($sqlserver, $sqluser, $sqlpassword, $database);
			if( !empty( $this->db_connect_id ) ) {
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return $this->db_connect_id;
			} else	{
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return false;
			}
		}

		public function sql_close() {
			@mysql_close( $this->db_connect_id );
		}

		public	function sql_nextid() {
			$start_time = $this->timing();
			if( ! empty( $this->db_connect_id  ) ) {
				$result = @mysqli_insert_id($this->db_connect_id);
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return $result;
			} else {
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return false;
			}
		}

		public	function sql_object( $query_id = '' ) {
			if ( !empty( $query_id ) ) {
				$query_id = @mysqli_fetch_object( $query_id );
				return $query_id;
			} else {
				return false;
			}
		}
		public	function query( $query = '', $type= false, $transaction = false ) {
			$query = str_ireplace('union', 'uni&shy;on', $query);
			$start_time = $this->timing();
			!empty( $type ) ? $type : $type = 'Query';
			$query_error = false;
			$sql  = @mysqli_query( $this->db_connect_id, $query );
			if( ! empty( $sql ) ){
				$this->num_queries++;
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				maxdebug($query, '', $endtime, $type);
				return $sql;
			} else {
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				maxdebug( '' , $query, $endtime, $type);
				query_die(CORE_ERROR, 'Could not Query', '', '', '', $query);
				return ( $transaction == 'END_TRANSACTION' ) ? true : false;
			}
		}
		public	function get_object( $query = '', $transaction = false ) {
				$start_time = $this->timing();
				$result = $this->query( $query, 'Get Object' );
				$returned = @mysqli_fetch_object( $result );
			if( empty( $returned ) ){
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return ( $transaction == 'END_TRANSACTION' ) ? true : false;
			} else {
				@mysqli_free_result($result);
				$endtime = $this->timing();
				$this->sql_time += $endtime - $start_time;
				return $returned;
			}
		}
		public	function get_list_object($query) {
			$start_time = $this->timing();
			$returned = array();
			$result = $this->query($query, 'Get List Object');
			while ($row = @mysqli_fetch_object( $result ) ) {
				$returned[] = $row;
			}
			@mysqli_free_result($result);
			$endtime = $this->timing();
			$this->sql_time += $endtime - $start_time;
			return $returned;
		}
		public	function get_list_row($query) {
			$start_time = $this->timing();
			$returned = array();
			$result = $this->query($query, 'Get List Row');
			while ($row = @mysqli_fetch_array( $result ) ) {
				$returned[] = $row;
			}
			@mysqli_free_result($result);
			$endtime = $this->timing();
			$this->sql_time += $endtime - $start_time;
			return $returned;
		}
		public	function get_list($query) {
			$returned = array();
			$result = $this->query($query, 'Get List Array');
			while ($row = @mysqli_fetch_assoc($result)) {
				$returned[] = $row;
			}
			@mysqli_free_result($result);
			return $returned;
		}

		public	function get_row($query) {
			$start_time = $this->timing();
			$result = $this->query($query, 'Get Row');
			$returned = @mysqli_fetch_array($result);
			@mysqli_free_result($result);
			$endtime = $this->timing();
			$this->sql_time += $endtime - $start_time;
			return $returned;
		}
		public	function get_num($query) {
			$start_time = $this->timing();
			$result = $this->query($query, 'Get Num');
			$num = @mysqli_num_rows($result);
			@mysqli_free_result($result);
			$endtime = $this->timing();
			$this->sql_time += $endtime - $start_time;
			return $num;
		}
		public	function sql_free( $query_id = 0 ) {
			if (!empty($query_id) ) {
				@mysqli_free_result($query_id);
			} else {
				return false;
			}
		}
		public	function sql_error($query_id = 0) {
			$start_time = $this->timing();
			$result['message'] = @mysqli_error($this->db_connect_id);
			$result['code'] = @mysqli_errno($this->db_connect_id);
			$endtime = $this->timing();
			$this->sql_time += $endtime - $start_time;
			return $result;
		}

		public	function XMFbin($var) {
			$var = intval( $var );
			if ( preg_match( '`[0-1]`', $var ) ) {
				return (bool)$var;
			} else {
				query_die(XMFbin_ERROR, 'XMFbin not allow '.$var.'', '', '', '', $var);
			}
		}

		public	function XMFnum($var) {
			$var = intval( $var );
			if ( preg_match( '`[0-9]`', $var ) ) {
				return (int)$var;
			} else {
				query_die(XMFnum_ERROR, 'XMFnum not allow '.$var.'', '', '', '', $var);
			}
		}

		public	function XMFlang($var) {
			if ( empty( $var ) ) { return ; }
			if ( preg_match( '`(english|french|italian|spanish|japanese|all)`', $var ) or empty( $var ) ) {
				return $var;
			} else {
				query_die(XMFlang_ERROR, 'XMFlang not allow '.$var.'', '', '', '', $var);
			}
		}
	} // class sql_db
} // if ... define