<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied security MINIMUS directly...');

$tmp = INCLUDE_PATH.'kernel/perso/security.php';
if ( is_file( $tmp ) ) include_once( $tmp );

if( ! function_exists('Filtre_Module') ) {
	Function Filtre_Module( $var ) {
   		if ( stristr($var,'http\:\/\/') || stristr($var,'http:') || stristr($var,'..') || stristr($var,'script') || stristr($var,'cookie') || stristr($var,'iframe') || stristr($var,'applet') || stristr($var,'object') || stristr($var,'meta')) {
      			header('location: index.php'); die();
   		} else {
         		return (true);
   		}
	}
}

function stripos_clone($haystack, $needle, $offset=0) {
	return @stripos($haystack, $needle, $offset=0);
}

if( ! function_exists('FixQuotes') ) {
	Function FixQuotes ($what = false) {
		$what = str_replace("'","''",$what);
		while (stripos_clone($what, "\\\\'")) {
			$what = str_replace("\\\\'","'",$what);
		}
		return $what;
	}
}

if( ! function_exists('delQuotes') ) {
	Function delQuotes( $string ){
    		if (empty($string)) return NULL;
    	/* no recursive function to add quote to an HTML tag if needed */
	/* and delete duplicate spaces between attribs. */
	$tmp='';    # string buffer
	$result=''; # result string
	$i=0;
	$attrib=-1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
	$quote=0;   # Is a string quote delimited opened ? 0=no, 1=yes
	$len = strlen($string);
	while ($i<$len) {
		switch($string[$i]) { # What car is it in the buffer ?
		case "\"": #"       # a quote.
		if ($quote==0) {
			$quote=1;
		} else {
			$quote=0;
			if (($attrib>0) && ( !empty( $tmp ) )) { $result .= "=\"$tmp\""; }
			$tmp='';
			$attrib=-1;
		}
		break;
		case '=':           # an equal - attrib delimiter
		if ($quote==0) {  # Is it found in a string ?
		$attrib=1;
		if ( !empty( $tmp )) $result.=" $tmp";
		$tmp='';
		} else $tmp .= '=';
		break;
		case ' ':           # a blank ?
		if ($attrib>0) {  # add it to the string, if one opened.
		$tmp .= $string[$i];
		}
		break;
		default:            # Other
		if ($attrib<0)    # If we weren't in an attrib, set attrib to 0
		$attrib=0;
		$tmp .= $string[$i];
		break;
		}
		$i++;
	}
	if (($quote!=0) && ( !empty( $tmp ) )) {
		if ($attrib==1) $result .= '=';
		/* If it is the value of an atrib, add the '=' */
		$result .= "\"$tmp\"";  /* Add quote if needed (the reason of the function ;-) */
	}
	return $result;
	}
}

if( ! function_exists('Check_Html') ) {
	Function Check_Html( $str, $strip = false ) {
    		if (empty($str)) return NULL;
		global $AllowableHTML;
		if ( $strip == 'nohtml' ) unset( $AllowableHTML );
		$str = stripslashes($str);
		$str = str_ireplace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
		// Delete all spaces from html tags .
		$str = str_ireplace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
		// Delete all attribs from Anchor, except an href, double quoted.
		$str = str_ireplace("<[[:space:]]* img[[:space:]]*([^>]*)[[:space:]]*>", '', $str);
		// Delete all img tags
		$str = str_ireplace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?javascript[[:punct:]]*\"?[^>]*>", '', $str);
		// Delete javascript code from a href tags -- Zhen-Xjell @ http://nukecops.com
		$tmp = '';
		while ( preg_match('/<(\/?[[:alpha:]]*)[[:space:]]*([^>]*)>/',$str,$reg) ) {
			$i = strpos($str,$reg[0]);
			$l = strlen($reg[0]);
			if ($reg[1][0] == '/') {
				$tag = strtolower(substr($reg[1],1));
			} else {
				$tag = strtolower($reg[1]);
			}
			if ( !empty( $AllowableHTML[$tag] ) )
				if ($reg[1][0] == '/') {
					$tag = "</$tag>";
				} elseif (($a == 1) || ( empty( $reg[2] ) )) {
					$tag = "<$tag>";
				} else {
					$attrb_list = delQuotes( $reg[2] );
					$attrb_list = str_ireplace('&','&amp;', $attrb_list);
					$tag = "<$tag" . $attrb_list . ">";
				}
			else $tag = '';
			$tmp .= substr($str,0,$i) . $tag;
			$str = substr($str,$i+$l);
		}
		$str = $tmp . $str;
		$str = str_replace('<br>', '<br />', $str);
		return $str;
		exit;
		$str = str_ireplace('<\?','', $str);
		return $str;
	}
}


if( ! function_exists('Filter_Text') ) {
	Function Filter_Text( $Message, $strip = false ) {
    		if (empty($Message)) return NULL;
    		global $EditedMessage;
		$EditedMessage = check_html($EditedMessage, $strip);
		return ($EditedMessage);
	}
}

if( ! function_exists('RemoveCrlf') ) {
	Function RemoveCrlf( $str ) {
		if (empty($str)) return NULL;
		return strtr($str, "\015\012", ' ');
	}
}

if( ! function_exists('Secure') ) {
	Function Secure( $data, $type, $nohtml=false, $save=false ) {
		$data = trim( $data );
      		switch( $type ) {
			case 'num':
				$data = $GLOBALS['db']->XMFnum( $data );
			break;
			case 'bin':
				$data = $GLOBALS['db']->XMFbin( $data );
			break;
			case 'lang':
				$data = $GLOBALS['db']->XMFlang( $data );
			break;
			case 'strip':
				$data = stripslashes( $data );
			break;
			default:
				$data = $data;
			break;
		}

      		switch( $nohtml ) {
			case 'clean':
				$data = strip_tags( $data );
			break;
			case 'hard':
				$data = strip_tags( $data );
				$data = str_ireplace("[<>/\?&`~@#\$%\^*']",'', $data);
			break;
			case '1':
				$data = check_html( $data, 'nohtml' );
			break;
			case 'nohtml':
				$data = check_html( $data, 'nohtml' );
			break;
			case 'html':
				$data = check_html( $data, 'html' );
			break;
			default:
				$data = $data;
			break;
		}
      		switch( $save ) {
			case 'fck':
				$data = stripslashes( FixQuotes( $data ) );
			break;
			case 'sec':
				$data = addslashes( htmlentities( $data, ENT_QUOTES ) );
			break;
			case 'xss':
			//$data = htmlentities( mysql_real_escape_string( strip_tags( $data ) ) );
				$data = addslashes( htmlentities( strip_tags( $data ), ENT_QUOTES ) );
			break;
			default:
				$data = $data;
			break;
		}
		$data = str_replace('<br>', '<br />', $data);
		return $data;
	}
}

if( ! function_exists('Secure_Empty') ) {
	Function Secure_Empty( $data ) {
		$data = secure( $data, '', 'hard', 'sec');
		if ( empty( $data ) ) {
			br(2);
			echo '<div id="panel_admin">'._SECURE_IS_EMPTY.'<br/>'._GOBACK.'</div>';
			br(2);
			Incof();
			die();
		} else {
			return TRUE;
		}
	}
}

if( ! function_exists('Control_Access') ) {
	Function Control_Access( $text = false ) {
		if ( ! stristr( strip_tags( $_SERVER['HTTP_REFERER'] ), strip_tags( $_SERVER['SERVER_NAME'] ) ) ) die('Illegal access :'.$text);
	}
}