<?php
/************************************************************************/
/* Minimus Blog: Web Portal System                                      */
/* ===============================                                      */
/* Write by Cyril Levert                                                */
/* Copyright (c) 2009-2010                                              */
/* http://www.php-minimus.org                                           */
/* dev@php-minimus.org                                                  */
/*                                                                      */
/* This program is free software.                                       */
/************************************************************************/
/* Based on PHP-Maximus: Web Portal System                              */
/************************************************************************/
defined('MINIMUS') or die ('Access denied utility MINIMUS directly...');

$tmp = INCLUDE_PATH.'kernel/perso/utility.php';
if ( is_file( $tmp ) ) include_once( $tmp );

if( ! function_exists('HelpMe') ) {
	FUNCTION HelpMe( $text, $title=false, $type=false, $side=false, $position=false ) {
		GLOBAL $textcolor2;
		$title = addslashes( $title );
		$text  = addslashes( $text );
  		! empty ( $side ) ? $side = 'LEFT' : $side = 'RIGHT';
  		! empty ( $position ) ? $position = 'BELOW' : $position = 'ABOVE';
  		! empty ( $type ) ? $type = 'images/infoicon.png' : $type = 'images/helpicon.png';
  		! empty ( $title ) ? $title = htmlentities($title) : $title = _HELP_MAXIMUS;
		return "<a href=\"javascript:void(0);\" onmouseover=\"return overlib('$text', SHADOW, SHADOWOPACITY, 45,  $position, $side, CAPTION, '$title', STATUS, '$title', WIDTH, 300, OFFSETY, 10, FGCOLOR, '#ffffff', BGCOLOR, '$textcolor2', TEXTCOLOR, '#000000', CAPCOLOR, '#ffffff', CLOSECOLOR, '#ffffff', CAPICON, '$type', BORDER, '1');\" onmouseout=\"return nd();\"><img src='$type' alt='' border='0' height='12' width='12' /></a>&nbsp;";
	}
}

if ( ! function_exists('CronHours') ) {
	Function CronHours($hours1, $hours2, $namecron, $cronfile) {
		global $operation, $datecron;
		$hours1   = secure( $hours1, 'num');
		$hours2   = secure( $hours2, 'num');
		$namecron = secure( $namecron, 'strip', '', 'xss');
		$cronfile = secure( $cronfile, 'strip', '', 'xss');
		if ($hours1 == $hours2) return;
		$today = getdate();
    		$day = secure( $today['mday'], 'num');
   		if ($day < 10)
			$day = '0'.$day;
    		$month = secure( $today['mon'], 'num');
   		if ($month < 10)
			$month = '0'.$month;
    		$year = secure( $today['year'], 'num');
    		$hour = secure( $today['hours'], 'num');
    		if ($hour < 10)
			$hour = '0'.$hour;
    		$min = secure( $today['minutes'], 'num');
    		if ($min < 10)
			$min = '0'.$min;
    		$sec = secure( $today['seconds'], 'num');
    		if ($sec < 10)
			$sec = '0'.$sec;
    		$complete    = $day.':'.$month.':'.$year.':'.$hour.':'.$min.':'.$sec;
    		$hoursactual = $hour.''.$min;
   		$dayactual   = $day.''.$month;

		if (($hours1 >=  $hoursactual ) or ( $hoursactual > $hours2)) return;
		$tmp = INCLUDE_PATH.''.CACHE.'/cron/cron-'.$namecron.'.php';
		if ( is_file( $tmp ) ) include_once ( $tmp );

		if (($operation == 1) && ($datecron == $dayactual )) {
			return;
		} else {
			include_once (INCLUDE_PATH.''.CACHE.'/cron/config-'.$cronfile.'.php');
		}

		if (($hours1 <=  $hoursactual ) & ( $hoursactual < $hours2)) {
			$crondatafile = INCLUDE_PATH.''.CACHE.'/cron/cron-'.$namecron.'.php';
			$file     = @fopen( $crondatafile, 'w');
			$content  = "<?php\n\n";
			$content .= "\$realised = \"$complete\";\n\n";
			$content .= "\$operation = \"1\";\n";
			$content .= "\$datecron = \"$day$month\";";
			@fwrite($file, $content);
			@fclose($file);
		}
	}
}

if ( ! function_exists('Is_Active') ) {
	Function Is_Active( $module ) {
		 return 1;
	}
}

if ( ! function_exists('Is_Module') ) {
	Function Is_Module( $module ) {
		if ( is_dir(INCLUDE_PATH.'modules/'.$module)  AND is_file( INCLUDE_PATH.'modules/'.$module.'/index.php' ) ) return true;
	}
}

if ( ! function_exists('Online') ) {
	Function Online() {
		global $cookie;
        	if ( defined('USER_ALLOW') ) {
			$uname = secure( $cookie[1], '', '', 'xss' );
        		$guest = 0;
       		} else {
       			$uname = GET_IP;
        		$guest = 1;
        	}
		if ( !defined('ADMIN_MAX')) {
			$past =  MAX_TIME - MAXADV_TIMESESSION_U ;
			$past2 = MAX_TIME - MAXADV_TIMESESSION_V ;
			if ( @ empty(  $_SESSION['session'] ) ) {
				$GLOBALS['db']->query("DELETE FROM `".TABLE_SESSION."` WHERE ( `guest`=0 AND `time` < '$past' ) OR ( `guest`=1 AND `time`<'$past2' )");
			}
			@ $_SESSION['session'] = '1' ;
		}
		if ( @ empty( $_SESSION['x_session_time'] ) ) {
   			$numsessions = $GLOBALS['db']->get_num("SELECT `time` FROM `".TABLE_SESSION."` WHERE `uname`='".addslashes($uname)."'");
			@ $_SESSION['test_session_time'] = 1 ;
			@ $_SESSION['x_session_time'] = $numsessions ;
		} else {
			$numsessions = @ $_SESSION['x_session_time'];
		}

		if ( !empty( $numsessions) ) {
			$GLOBALS['db']->query("UPDATE `".TABLE_SESSION."` SET `time`='".addslashes( MAX_TIME )."', `host_addr`='".addslashes( GET_IP )."', `Wurl`='".addslashes( MAX_URL )."', `Wname`='".addslashes( MODULE_NAME )."' WHERE `uname`='".addslashes($uname)."'");
		} else {
			$GLOBALS['db']->query("INSERT INTO `".TABLE_SESSION."` (`uname`, `time`, `host_addr`, `guest`, `Wurl`, `Wname`) VALUES ('".addslashes($uname)."', '".addslashes( MAX_TIME )."', '".addslashes( GET_IP )."', '$guest', '".addslashes( MAX_URL )."', '".addslashes( MODULE_NAME )."')");
		}

		if ( defined('USER_ALLOW') && UserLastSeen_Status === true ) {
			if ( @ empty( $_SESSION['test_user_lastseen'] ) ) {
				$num = $GLOBALS['db']->get_num("SELECT `id` FROM `".TABLE_USERS_LASTSEEN."` WHERE `username` = '$cookie[1]' ");
				@ $_SESSION['user_lastseen'] = $num;
			} else {
				@ $_SESSION['test_user_lastseen'] = 1 ;
				$num  = @ $_SESSION['user_lastseen'];
			}
			if ( !empty( $num ) ) {
				$GLOBALS['db']->query("UPDATE `".TABLE_USERS_LASTSEEN."` SET `xdate`='".MAX_TIME."', `Wurl`='".MAX_URL."', `Wname`='".MODULE_NAME."' WHERE `username`  REGEXP BINARY '$cookie[1]' ");
				@ $_SESSION['user_lastseen'] = 1 ;
			} else {
				$GLOBALS['db']->query("INSERT INTO `".TABLE_USERS_LASTSEEN."` VALUES (NULL, '$cookie[1]', '".MAX_TIME."', '".MAX_URL."', '".MODULE_NAME."', '".GET_IP."')");
				@ $_SESSION['user_lastseen'] = 0 ;
       			}
		}
	}
}

if ( ! function_exists('FormatTimestamp') ) {
	Function FormatTimestamp($time) {
		if ( empty( $time ) ) return NULL;
    			global $config;
			$datetime = '';
    			@setlocale(LC_TIME, $config['locale']);
    			( !empty($config['decalage']) ) ? $decalage1 = ( $config['decalage'] * 3600 ) : $decalage1 = 0;
    			if ( !@is_numeric($time) ) {
        			@preg_match('/([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})/', $time, $datetime);
        			$time = @gmmktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]) + $decalage1 ;
    			}
   		$time -= @date('Z');
    		$datetime = @ucfirst( @strftime(_DATESTRING, $time + $decalage1) );
    		return $datetime;
	}
}

if ( ! function_exists('Paid') ) {
	Function Paid() {
	}
}


if ( ! function_exists('Update_Points') ) {
	Function Update_Points( $id = FALSE ) {
	}
}

if ( ! function_exists('Serverload') ) {
	Function Serverload() {
		if ( MAXADV_VIEWSPAGE == 1 ) return;
		if ( Serverload_Status === false ) return;
		$calcul = MAX_TIME - 3600;
		if ( @ empty( $_SESSION['serverload'] ) ) {
			$GLOBALS['db']->query("DELETE FROM `".TABLE_SERVERLOAD."` WHERE `hours` < '".secure( $calcul, 'num')."' ");
			@ $_SESSION['serverload'] = '1' ;
			if ( $GLOBALS['db']->get_num('SELECT `id` FROM `'.TABLE_SERVERLOAD.'`') >= 5000 ) {
				$GLOBALS['db']->query('DELETE QUICK FROM `'.TABLE_SERVERLOAD.'`');
			}
		}
		$GLOBALS['db']->query("INSERT INTO `".TABLE_SERVERLOAD."` (`id`, `hours`) VALUES (NULL, '".MAX_TIME."')");
		$num = $GLOBALS['db']->get_num('SELECT `id` FROM `'.TABLE_SERVERLOAD.'`');
		return $num;
	}
}

if ( ! function_exists('Br') ) {
	Function Br( $num ) {
		$num = secure( $num, 'num');
		$i = 1;
		while ( $i <= $num ) {
			echo '<br />'."\n";
			$i++;
       		}
	}
}

if ( ! function_exists('Carousel') ) {
	FUNCTION Carousel( $what ) {
		if ( empty( $what ) ) return false;
		$patterns = '`\[carousel\](.+?)\[/carousel\]`is';
		preg_match_all( $patterns, $what, $matches, PREG_SET_ORDER);
		if ( !empty( $matches[0][1] ) ) {
			if ( is_file('modules/MiniGold/Carousels/'.$matches[0][1].'.xml') ) {
				global $prefix;
				include_once('modules/MiniGold/includes/constants.php');
				$sql = "SELECT `size` FROM `".TABLE_MINIGOLD_CAROUSEL."` WHERE `nom`='".secure($matches[0][1], '', '', 'xss')."' ";
				$row    = $GLOBALS['db']->get_object( $sql );
				$size   = secure( $row->size, 'strip', 'clean');
				$t = explode('*', $size );
				$larg = $t[0];
				$haut = $t[1];

				$replaces = '<div style="width:'.$larg.'px;height:'.$haut.'px;margin:0px auto;">
						<div id="\1">
							<p>This slideshow requires <a href="http://www.adobe.com/go/getflashplayer">Adobe Flash Player 9.0</a> (or higher). JavaScript must be enabled.</p>
						</div>
					</div>
					<script type="text/javascript">
						swfobject.embedSWF("Carousel.swf", "\1", "'.$larg.'", "'.$haut.'", "9.0.0", false, {xmlfile:"modules/MiniGold/Carousels/\1.xml", loaderColor:"0x666666"}, {wmode: "transparent"});
					</script>';

				$text = preg_replace($patterns,$replaces,$what);
				//unset( $what );
				return  $text ;
			} else {
				return 'This carousel not exists !';
			}
		} else {
			return  $what ;
		}
	}
}

if ( ! function_exists('PHPCarousel') ) {
	FUNCTION PHPcarousel( $what ) {
		if ( empty( $what ) ) return false;
		global $prefix;
		include_once('modules/MiniGold/includes/constants.php');
		$sql = "SELECT `size` FROM `".TABLE_MINIGOLD_CAROUSEL."` WHERE `nom`='".secure($what, '', '', 'xss')."' ";
		$row    = $GLOBALS['db']->get_object( $sql );
		$size   = secure( $row->size, 'strip', 'clean');
		$t = explode('*', $size );
		$larg = secure( $t[0], 'num');
		$haut = secure( $t[1], 'num');
		if ( is_file('modules/MiniGold/Carousels/'.$what.'.xml') ) {
			return '<div style="width:'.$larg.'px;height:'.$haut.'px;margin:-20px auto 0px auto;">
				<div id="'.$what.'">
					<p>This slideshow requires <a href="http://www.adobe.com/go/getflashplayer">Adobe Flash Player 9.0</a> (or higher). JavaScript must be enabled.</p>
				</div>
			</div>
			<script type="text/javascript">
				swfobject.embedSWF("Carousel.swf", "'.$what.'", "'.$larg.'", "'.$haut.'", "9.0.0", false, {xmlfile:"modules/MiniGold/Carousels/'.$what.'.xml", loaderColor:"0x666666"}, {wmode: "transparent"});
			</script>';
		} else {
			return 'This carousel not exists !';
		}
	}
}

if ( ! function_exists('MiniGold') ) {
	FUNCTION MiniGold( $image ) {
		$patterns = array(
			'`\[minigold\](.+?)\[/minigold\]`is',
			'`\[minigoldvignette\](.+?)\[/minigoldvignette\]`is',
			'`\[minigoldmax\](.+?)\[/minigoldmax\]`is',
			'`\[minigoldr\](.+?)\[/minigoldr\]`is',
			'`\[minigoldrvignette\](.+?)\[/minigoldrvignette\]`is',
			'`\[minigoldrmax\](.+?)\[/minigoldrmax\]`is'
		);
		$replaces =  array(
			'<img src="modules/MiniGold/Thumbs/\1" style="float:left;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />',
			'<img src="modules/MiniGold/Thumbs/\1" style="float:left;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />',
			'<img src="modules/MiniGold/Photos/\1" style="float:left;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />',
			'<img src="modules/MiniGold/Thumbs/\1" style="float:right;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />',
			'<img src="modules/MiniGold/Thumbs/\1" style="float:right;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />',
			'<img src="modules/MiniGold/Photos/\1" style="float:right;border:1px dotted #808080;padding:5px;margin:0 5px 30px 5px;clear:both;" alt="" />'
		);
		$image = preg_replace($patterns,$replaces,$image);
		return  carousel( $image ) ;
	}
}

if ( ! function_exists('Div_Alert') ) {
	FUNCTION Div_Alert( $mess ) {
        	echo '<div class="center bold" style="border:red dotted 1px;color:red;">'.$mess.'</div><br/>';
	}
}

if ( ! function_exists('Div_Error') ) {
	FUNCTION Div_Error( $mess ) {
		echo '<div id="errorDiv" class="error">'.$mess.'</div>';
	}
}

if ( ! function_exists('Div_Succes') ) {
	FUNCTION Div_Succes( $mess ) {
		echo '<div id="succesDiv" class="succes">'.$mess.'</div>';
	}
}

if ( ! function_exists('Go_Back') ) {
	FUNCTION Go_Back() {
		echo '<div align="center">'._GOBACK.'</div>';
	}
}